/*
 * MIT License
 *
 * Copyright (c) 2020 Alexey Edelev <semlanik@gmail.com>
 *
 * This file is part of NeuralNetwork project https://git.semlanik.org/semlanik/NeuralNetwork
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify,
 * merge, publish, distribute, sublicense, and/or sell copies of the Software, and
 * to permit persons to whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies
 * or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package cluster

import (
	fmt "fmt"
	"net"
)

type NeuraNetworkCluster struct {
	address     string
	activeUnits Units
	streams     []NeuralNetworkCluster_RegisterServer
	unitsQueue  chan *Unit
}

func NewNeuraNetworkCluster(address string) (cl *NeuraNetworkCluster) {
	cl = nil
	if address == "" {
		return
	}

	cl = &NewNeuraNetworkCluster{
		address: address,
		unitsQueue: make(chan *Unit, 10)
	}
}

func (cl *NeuraNetworkCluster) serveClients() {
	stream.Send(&cl.activeUnits)
	cl.activeUnits.List = append(cl.activeUnits.List, unit)
	go func() {
		for _, stream := range cl.streams {
		}
	}()
}

func (cl *NeuraNetworkCluster) Run() {
	grpcServer := grpc.NewServer()
	cluster.RegisterNeuralNetworkClusterServer(grpcServer, cl)
	lis, err := net.Listen("tcp", address)
	if err != nil {
		fmt.Printf("Failed to listen: %v\n", err)
	}

	fmt.Printf("Listen %v\n", address)
	if err := grpcServer.Serve(lis); err != nil {
		fmt.Printf("Failed to serve: %v\n", err)
	}
}

func (cl *NeuraNetworkCluster) Register(unit *Unit, stream NeuralNetworkCluster_RegisterServer) error {
	cl.unitsQueue <- unit
	return nil
}
